<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMagellanTracerGeoZoneInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfMagellanTracerGeoZoneInfo extends AbstractStructArrayBase
{
    /**
     * The MagellanTracerGeoZoneInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MagellanTracerGeoZoneInfo[]
     */
    public $MagellanTracerGeoZoneInfo;
    /**
     * Constructor method for ArrayOfMagellanTracerGeoZoneInfo
     * @uses ArrayOfMagellanTracerGeoZoneInfo::setMagellanTracerGeoZoneInfo()
     * @param \StructType\MagellanTracerGeoZoneInfo[] $magellanTracerGeoZoneInfo
     */
    public function __construct(array $magellanTracerGeoZoneInfo = array())
    {
        $this
            ->setMagellanTracerGeoZoneInfo($magellanTracerGeoZoneInfo);
    }
    /**
     * Get MagellanTracerGeoZoneInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MagellanTracerGeoZoneInfo[]|null
     */
    public function getMagellanTracerGeoZoneInfo()
    {
        return isset($this->MagellanTracerGeoZoneInfo) ? $this->MagellanTracerGeoZoneInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMagellanTracerGeoZoneInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMagellanTracerGeoZoneInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMagellanTracerGeoZoneInfoForArrayConstraintsFromSetMagellanTracerGeoZoneInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMagellanTracerGeoZoneInfoMagellanTracerGeoZoneInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfMagellanTracerGeoZoneInfoMagellanTracerGeoZoneInfoItem instanceof \StructType\MagellanTracerGeoZoneInfo) {
                $invalidValues[] = is_object($arrayOfMagellanTracerGeoZoneInfoMagellanTracerGeoZoneInfoItem) ? get_class($arrayOfMagellanTracerGeoZoneInfoMagellanTracerGeoZoneInfoItem) : sprintf('%s(%s)', gettype($arrayOfMagellanTracerGeoZoneInfoMagellanTracerGeoZoneInfoItem), var_export($arrayOfMagellanTracerGeoZoneInfoMagellanTracerGeoZoneInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MagellanTracerGeoZoneInfo property can only contain items of type \StructType\MagellanTracerGeoZoneInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MagellanTracerGeoZoneInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MagellanTracerGeoZoneInfo[] $magellanTracerGeoZoneInfo
     * @return \ArrayType\ArrayOfMagellanTracerGeoZoneInfo
     */
    public function setMagellanTracerGeoZoneInfo(array $magellanTracerGeoZoneInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($magellanTracerGeoZoneInfoArrayErrorMessage = self::validateMagellanTracerGeoZoneInfoForArrayConstraintsFromSetMagellanTracerGeoZoneInfo($magellanTracerGeoZoneInfo))) {
            throw new \InvalidArgumentException($magellanTracerGeoZoneInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($magellanTracerGeoZoneInfo) || (is_array($magellanTracerGeoZoneInfo) && empty($magellanTracerGeoZoneInfo))) {
            unset($this->MagellanTracerGeoZoneInfo);
        } else {
            $this->MagellanTracerGeoZoneInfo = $magellanTracerGeoZoneInfo;
        }
        return $this;
    }
    /**
     * Add item to MagellanTracerGeoZoneInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\MagellanTracerGeoZoneInfo $item
     * @return \ArrayType\ArrayOfMagellanTracerGeoZoneInfo
     */
    public function addToMagellanTracerGeoZoneInfo(\StructType\MagellanTracerGeoZoneInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MagellanTracerGeoZoneInfo) {
            throw new \InvalidArgumentException(sprintf('The MagellanTracerGeoZoneInfo property can only contain items of type \StructType\MagellanTracerGeoZoneInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MagellanTracerGeoZoneInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MagellanTracerGeoZoneInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MagellanTracerGeoZoneInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MagellanTracerGeoZoneInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MagellanTracerGeoZoneInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MagellanTracerGeoZoneInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MagellanTracerGeoZoneInfo
     */
    public function getAttributeName()
    {
        return 'MagellanTracerGeoZoneInfo';
    }
}
